/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2012 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *
 */

/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tLinetracerTaskBody_template.c => src/tLinetracerTaskBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * maxTurn          int16_t          ATTR_maxTurn    
 * minTurn          int16_t          ATTR_minTurn    
 * kp               float32_t        ATTR_kp         
 * lightThreshold   uint16_t         VAR_lightThreshold
 * edge             int8_t           VAR_edge        
 * black            uint16_t         VAR_black       
 * white            uint16_t         VAR_white       
 * count            int32_t          VAR_count       
 *
 * ƤӸؿ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cLightSensor  signature: sSensor context: task
 *   void           cLightSensor_getValue( uint16_t* value );
 * call port : cLightSensorControl  signature: sSensorControl context: task
 *   void           cLightSensorControl_on( );
 *   void           cLightSensorControl_off( );
 * call port : cBalancerControl  signature: sBalancerControl context: task
 *   void           cBalancerControl_setSpeed( int16_t speed );
 *   void           cBalancerControl_getSpeed( int16_t* speed );
 *   void           cBalancerControl_setTurn( int16_t turn );
 *   void           cBalancerControl_getTurn( int16_t* turn );
 *   void           cBalancerControl_calibrate( );
 *
 * #[</PREAMBLE>]# */

/* ץȥѿ򤳤˽񤭤ޤ */
#include "tLinetracerTaskBody_tecsgen.h"
#include <t_syslog.h>

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tLinetracerTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	uint16_t light;
	int16_t turn;
    float32_t turn_f;

    cLightSensor_getValue(&light);
	
    turn_f = (float32_t)(light - VAR_lightThreshold) * ATTR_kp;

    if(turn_f > (float32_t)ATTR_maxTurn){
        turn = ATTR_maxTurn;
    } else if(turn_f < (float32_t)ATTR_minTurn){
        turn = ATTR_minTurn;
    } else {
        turn = (int8_t)turn_f;
    }

	cBalancerControl_setTurn(VAR_edge * turn);

    if(VAR_count++ == 100){
        syslog(LOG_NOTICE, "line tracer running. turn(%d),light(%d),threshold(%d)",turn,light,VAR_lightThreshold);
        VAR_count = 0;
    }
}

/* #[<ENTRY_PORT>]# eLinetracerControl
 * entry port: eLinetracerControl
 * signature:  sLinetracerControl
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eLinetracerControl_setLightThreshold
 * name:         eLinetracerControl_setLightThreshold
 * global_name:  tLinetracerTaskBody_eLinetracerControl_setLightThreshold
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eLinetracerControl_setLightThreshold(uint8_t color, uint16_t light)
{
    switch(color){
        case 0:
            if(light == 0){
                cLightSensor_getValue(&light);
            }
            VAR_black = light;
            break;
        case 1:
            if(light == 0){
                cLightSensor_getValue(&light);
            }
            VAR_white = light;
            break;
        case 2:
            if((VAR_white > light) || (light > VAR_black)){
                cLightSensor_getValue(&light);
            }
            VAR_lightThreshold = light;
            break;
        default:
            break;
    }
}

/* #[<ENTRY_FUNC>]# eLinetracerControl_getLightThreshold
 * name:         eLinetracerControl_getLightThreshold
 * global_name:  tLinetracerTaskBody_eLinetracerControl_getLightThreshold
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eLinetracerControl_getLightThreshold(uint8_t color, uint16_t* light)
{
    switch(color){
        case 0:
            *light = VAR_black;
            break;
        case 1:
            *light = VAR_white;
            break;
        case 2:
            *light = VAR_lightThreshold;
            break;
        default:
            break;
    }
}

/* #[<ENTRY_FUNC>]# eLinetracerControl_setEdge
 * name:         eLinetracerControl_setEdge
 * global_name:  tLinetracerTaskBody_eLinetracerControl_setEdge
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eLinetracerControl_setEdge(int8_t edge)
{
    VAR_edge = edge;
}

/* #[<ENTRY_FUNC>]# eLinetracerControl_getEdge
 * name:         eLinetracerControl_getEdge
 * global_name:  tLinetracerTaskBody_eLinetracerControl_getEdge
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eLinetracerControl_getEdge(int8_t* edge)
{
    *edge = VAR_edge;
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
