/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *
 */

/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tTailControllerTaskBody_template.c => src/tTailControllerTaskBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * tailAngleStop    int32_t          ATTR_tailAngleStop
 * tailAngleDrive   int32_t          ATTR_tailAngleDrive
 * kp               float32_t        ATTR_kp         
 * maxPwm           int8_t           ATTR_maxPwm     
 * minPwm           int8_t           ATTR_minPwm     
 * targetAngle      int32_t          VAR_targetAngle 
 *
 * ƤӸؿ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cTailMotor  signature: sMotor context: task
 *   void           cTailMotor_setPWM( int8_t pwm, bool_t brakeMode );
 *   void           cTailMotor_setRevolution( int32_t revolution );
 *   void           cTailMotor_getRevolution( int32_t* revolution );
 *
 * #[</PREAMBLE>]# */

/* ץȥѿ򤳤˽񤭤ޤ */
#include "tTailControllerTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tTailControllerTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	float32_t pwm_f;
	int8_t pwm;
	int32_t rev;

	cTailMotor_getRevolution(&rev);

	pwm_f = (float32_t)(VAR_targetAngle - rev) * ATTR_kp;

	if(pwm_f > (float32_t)ATTR_maxPwm){
		pwm = ATTR_maxPwm;
	} else if(pwm_f < (float32_t)ATTR_minPwm){
		pwm = ATTR_minPwm;
	} else {
		pwm = (int8_t)pwm_f;
	}

	cTailMotor_setPWM(pwm, 1);
}

/* #[<ENTRY_PORT>]# eCalibrate
 * entry port: eCalibrate
 * signature:  sCalibrate
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eCalibrate_body
 * name:         eCalibrate_body
 * global_name:  tTailControllerTaskBody_eCalibrate_body
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eCalibrate_body()
{
	int32_t rev, pre_rev;
	
	cTailMotor_setPWM(ATTR_minPwm, 1); // ղž

	cTailMotor_getRevolution(&rev);
	do{
		pre_rev = rev;
		delay(100);
		cTailMotor_getRevolution(&rev);
	} while(rev != pre_rev); // ž«ޤ

	cTailMotor_setPWM(0, 1); // 
	cTailMotor_setRevolution(0); // ž
}

/* #[<ENTRY_PORT>]# eTailController
 * entry port: eTailController
 * signature:  sTailController
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTailController_signalStop
 * name:         eTailController_signalStop
 * global_name:  tTailControllerTaskBody_eTailController_signalStop
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eTailController_signalStop()
{
	VAR_targetAngle = ATTR_tailAngleStop;
}

/* #[<ENTRY_FUNC>]# eTailController_signalStart
 * name:         eTailController_signalStart
 * global_name:  tTailControllerTaskBody_eTailController_signalStart
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eTailController_signalStart()
{
	VAR_targetAngle = ATTR_tailAngleDrive;
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
