/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *
 */

/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tSampleTaskBody_template.c => src/tSampleTaskBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * ƤӸؿ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cSound  signature: sSound context: task
 *   void           cSound_beepTone( uint32_t frequency, uint32_t msecond );
 *   void           cSound_setVolume( uint8_t volume );
 *
 * #[</PREAMBLE>]# */

/* ץȥѿ򤳤˽񤭤ޤ */
#include "tSampleTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tSampleTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	int8_t vol = 0;  // 겻
	
	while(1){
		cSound_setVolume(vol);     // ̤
		cSound_beepTone(440, 100); // 440Hz100msecδֲĤ餹

		vol += 10;                 // ̤10%夲
		if(vol > 100){
			vol = 0;
		}

		delay(1000); // 1Ԥ
	}
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
