/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ƥ٥ϡmindstormsNXTѡ
 */

#include "tPutLogMindstormsNXT_tecsgen.h"
#include "target_at91sam7s.h"
#include <unistd.h>
#include "target_serial.h"

/*
 *  ƥ٥ϤΤʸ
 */

inline void
rot_target_low_send_buf(CELLCB *p_cellcb)
{
	if(VAR_sendBufferPointer == VAR_sendBuffer1) {
		VAR_sendBufferPointer = VAR_sendBuffer2;
	} else {
		VAR_sendBufferPointer = VAR_sendBuffer1;
	}
}

/*
 *  åȰ¸ʸ(٥)
 */
void
target_fputc(CELLCB *p_cellcb, char c)
{

	if(__builtin_expect(VAR_sendBufferPointer == NULL, 0)) {
		VAR_sendBufferPointer = VAR_sendBuffer1; // Ϥݥ󥿤
	}
	
	VAR_sendBufferPointer[VAR_sendBufferCount] = c; // Хåեʸ
	VAR_sendBufferCount++;                            // Хåեʸ򥤥󥯥

	if(c == '\n' || VAR_sendBufferCount >= ATTR_sendBufferSize) { // ʸξ or Хåեեξ
		/*
		 *  ǽ(DMAžλ)ˤʤޤԤ
		 */
		while((sil_rew_mem((void *)(ATTR_US1_BASE + TOFF_PDC_TNCR))) != 0);
		while((sil_rew_mem((void *)(ATTR_US1_BASE + TOFF_PDC_TCR))) != 0);

		sil_wrw_mem((void *)(ATTR_US1_BASE + TOFF_PDC_TNPR), (uint_t)(VAR_sendBufferPointer)); // Υɥ쥹
		sil_wrw_mem((void *)(ATTR_US1_BASE + TOFF_PDC_TNCR), VAR_sendBufferCount); // Хȿ
		
		rot_target_low_send_buf(p_cellcb); // Хåեؤ
		VAR_sendBufferCount = 0U; // Хåեʸꥻå
	}

}


/*
 *  åȰ¸ʸ
 */
ER
ePutLog_putChar(CELLIDX idx, char c)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	if((!cBluetooth_isConnected()) || (cSIOPort_isOpened() == false)) { // bluetooth³ƤʤǤʤ
		return E_SYS;
	}

	/*
	 *  LFCR
	 */
	if(c == '\n') {
		target_fputc(p_cellcb, '\r');
	}
	
	target_fputc(p_cellcb, c);

	return E_OK;
}
