/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_syssvc.h 1426 2009-01-08 02:07:29Z ertl-honda $
 */

/*
 *  ƥॵӥΥåװ¸BTC090ѡ
 *
 *  ƥॵӥΥåװ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե̵ʤ
 *  ߡ
 */
#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME "mindstormsNXT(AT91SAM7S256)"

/*
 *  ƥϢ
 */
#define LOGTASK_PRIORITY	3		/* ͥ */

#define LOGTASK_STACK_SIZE	1024	/* åΰΥ */

#define LOGTASK_PORTID		1		/* ƥѤΥꥢݡֹ */

#define LOGTASK_INTERVAL	10U		/* ƥưֳ֡ʥߥá*/

#define LOGTASK_FLUSH_WAIT	1U		/* եåԤñ̻֡ʥߥá*/

/*
 *  ưåΥåץƥ̾
 */
#define CHIP_NAME    "AT91SAM7S(ARM)"

/*
 *  ƥ٥ϤΤʸ
 *
 *  åȰ¸ˡǡʸcɽ//¸롥
 */
extern void	target_fput_log(char c);

/*
 *  ƥϢ
 *
 *  ǥե̤ͤꡥ
 */

#endif /* TOPPERS_TARGET_SYSSVC_H */
