/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *
 */

/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tBalancerBody_inline_template.h => src/tBalancerBody_inline.h
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * #[</PREAMBLE>]# */

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBalancer
 * entry port: eBalancer
 * signature:  sBalancer
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBalancer_control
 * name:         eBalancer_control
 * global_name:  tBalancerBody_eBalancer_control
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eBalancer_control(int16_t forward, int16_t turn, uint16_t gyro, uint16_t gyroOffset, int32_t leftRevolution, int32_t rightRevolution, uint16_t battery, int8_t* pwm_l, int8_t* pwm_r)
{
    // Ωѥ饤֥ؿƤӽФ
    balance_control((float32_t)forward,
                    (float32_t)turn,
                    (float32_t)gyro,
                    (float32_t)gyroOffset,
                    (float32_t)leftRevolution,
                    (float32_t)rightRevolution,
                    (float32_t)battery,
                    pwm_l,
                    pwm_r);
}

/* #[<ENTRY_PORT>]# eInitialize
 * entry port: eInitialize
 * signature:  sInitializeRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eInitialize_main
 * name:         eInitialize_main
 * global_name:  tBalancerBody_eInitialize_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eInitialize_main()
{
    // Ωѥ饤֥ؿƤӽФ
    balance_init();
}

