#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2012 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: messages-load.rb 1744 2012-05-25 09:00:08Z okuma-top $
#++

# ϥåΥ case insensitive ΤᡢʸʸȤ
CHARSET_ALIAS = {
  "UJIS" => :eucJP,
  "UTF-8" => :utf8,
  "EUCJP" => :eucJP,   # ʲ case insensitive ˤ뤿
  "SJIS" => :sjis,
  "UTF8" => :utf8,
  "ISO8859-1" => :"iso8859-1"
}
LANG_ALIAS = {
  "C" => :en_US,
  "EN_US" => :en_US,   # ʲ case insensitive ˤ뤿
  "JA_JP" => :ja_JP
}
SUITABLE_CHARSET = {
  :ja_JP => [ :eucJP, :sjis, :utf8 ],
  :en_US => [ :"iso8859-1", :utf8, nil ]
}

#=== LANG Υѡ
#lang::String  "ja_JP.eucJP@cjknarrow", "C" ʤ
#RETURN:: [ :ja_JP, :eucJP, :cjknarrow ]
def parse_lang( lang )
  lang =~ /([^\.@]*)(\.([^@]*))?(@(.*))?/

  lang_terri = $1.to_sym if $1 != nil && $1 != ""
  # set_kcode_binary ˤꡢC.UTF-8 Τߤ̰ɬפʤʤä
  # if lang_terri == :C then    # LANG=C.* ϡ٤ 1 byte ʸɤȤư
  #  codeset = nil
  #  modifier = nil
  # else
    codeset = $3.to_sym if $3 != nil && $3 != ""
    modifier = $5.to_sym if $5 != nil && $5 != ""
  # end
  [ lang_terri, codeset, modifier ]
end

#=== lang, charset 褪Υå
#lang::Symbol    : :en_US, :ja_JP ʤ
#charset::Symbol : :eucJP, :utf8 ʤ
#RETURN:
#  [ lang, charset, result ]::result = false ξ lang, charset Ŭ
def resolve_alias_and_check( lang, charset )
  if LANG_ALIAS[ lang.to_s.upcase ] then
    ln = LANG_ALIAS[ lang.to_s.upcase ]
  else
    ln = lang
  end

  if CHARSET_ALIAS[ charset.to_s.upcase ] then
    cs = CHARSET_ALIAS[ charset.to_s.upcase ]
  else
    cs = charset
  end

  if SUITABLE_CHARSET[ ln ] == nil || SUITABLE_CHARSET[ ln ].index( cs ) == nil
    res = false
  else
    res = true
  end

  # p ln, cs, res
  [ ln, cs, res ]
end

#=== codepage Ф
#codepage 35ȤƲ
def get_win_codepage
  cmd_pipe = IO.popen('cmd /c chcp','r')
  cmd_pipe.read =~ /([0-9]{3,5})/
  cp = $1
  cmd_pipe.close
  return cp
end

#=== codepage  LANG ʸѴ
def codepage_to_lang cp
  if cp == "932" then
    "ja_JP.sjis"
  else
    "en_US"
  end
end

#=== 졢ʸɤ˴ؤѿ
# ʲν˥å졢ֺǸꤵ줿ͤѤ
#   ǥե
#   codepage  (exerb ǤΤ)
#   LANG Ķѿ
#   TECSGEN_LANG Ķѿ
#   TECSGEN_FILE_LANG Ķѿ (եʸɤΤ)
#   -k ץ (եʸɤΤ)
def set_lang_var

  if $IN_EXERB then
    # exerb ǤǤ codepage Τߤ򸫤
    cp = get_win_codepage
    lang = codepage_to_lang cp
    $LANG_FILE, $CHARSET_FILE, *dum = parse_lang( lang )
    $LANG_CONSOLE = $LANG_FILE
    $CHARSET_CONSOLE = $CHARSET_FILE

  elsif ENV[ 'LANG' ]then
    #  exerb ǤǤ LANG Ķѿ򸫤
    # cygwin console Ǥ codepage ˽äƽϤʿ¤ʤ

    $LANG_FILE, $CHARSET_FILE, *dum = parse_lang( ENV[ 'LANG' ] )
    $LANG_CONSOLE = $LANG_FILE
    $CHARSET_CONSOLE = $CHARSET_FILE
  end

  if ENV[ 'TECSGEN_LANG' ]then
    $LANG_FILE, $CHARSET_FILE, *dum = parse_lang( ENV[ 'TECSGEN_LANG' ] )
    $LANG_CONSOLE = $LANG_FILE
    $CHARSET_CONSOLE = $CHARSET_FILE
  end

  if ENV[ 'TECSGEN_FILE_LANG' ]then
    $LANG_FILE, $CHARSET_FILE, *dum = parse_lang( ENV[ 'TECSGEN_FILE_LANG' ] )
  end

  set_lang_by_option
end

#=== -k ץ󤫤եѤθ졢ʸѿ
def set_lang_by_option
  if $kcode == nil
    return
  end

  code = $kcode
  found = false
  res = $CODE_TYPE_ARRAY.index( code )
  if res == nil then
    print "-k: illegal kcode type #{code}. (#{$CODE_TYPE_ARRAY.join(", ")})\n"
    exit 1
  end

  case $kcode
  when "euc"
    $CHARSET_FILE = :eucJP
    $LANG_FILE = :ja_JP
  when "sjis"
    $CHARSET_FILE = :sjis
    $LANG_FILE = :ja_JP
  when "utf8"
    $CHARSET_FILE = :utf8
  when "none"
    $CHARSET_FILE = nil
    $LANG_FILE = "en_US"
  end

end

#=== Kconv 饹Ѥѿ
# 󤫤 Kconv ˴ؤѿ
def set_kconv_var

  # ʸɤ
  case $CHARSET_FILE           # string: "EUC" | "SJIS" | "NONE" | "UTF8"
  when :eucJP
    $KCODE_CDL = "EUC"
    $KCONV_CDL = Kconv::EUC
  when :sjis
    $KCODE_CDL = "SJIS"
    $KCONV_CDL = Kconv::SJIS
  when :utf8
    $KCODE_CDL = "UTF8"
    $KCONV_CDL = Kconv::UTF8
  else
    $KCODE_CDL = "BINARY"
    $KCONV_CDL = Kconv::BINARY
  end

  case $CHARSET_CONSOLE
  when :eucJP
    $KCODE_CONSOLE = "EUC"
    $KCONV_CONSOLE = Kconv::EUC
  when :sjis
    $KCODE_CONSOLE = "SJIS"
    $KCONV_CONSOLE = Kconv::SJIS
  when :utf8
    $KCODE_CONSOLE = "UTF8"
    $KCONV_CONSOLE = Kconv::UTF8
  else
    $KCODE_CONSOLE = "BINARY"
    $KCONV_CONSOLE = Kconv::BINARY
  end

  $KCODE_TECSGEN = "EUC"       # string: "EUC"  ΥեʸɡʥץǤϤʤ
  $KCONV_TECSGEN = Kconv::EUC  # const: 
  $KCODE     = $KCODE_TECSGEN # Υեʸɤ
end

#=== Ū KCODE  BINARY ѹ
# EUC  UTF8 ɤ߹ʸڤб
# ȤɤФ
# SJIS ξϡʸ꤬뤿ᡢѹʤ
def set_kcode_binary
  $KCODE_BACK = $KCODE
  if $KCODE != "SJIS" then
    $KCODE = "BINARY"
  end
end

#=== Ūʤ KCODE ѹ򸵤᤹
def reset_kcode
  $KCODE = $KCODE_BACK
end

#####
# $LANG_FILE         (C  en_US Ѵ)
# $LANG_CONSOLE      (C  en_US Ѵ)
# $CHARSET_FILE     եʸ
# $CHARSET_CONSOLE  󥽡ʸ

# ǥեȤѤߤΤȡ
$LANG_FILE_DEFAULT  = :en_US
$CHARSET_FILE_DEFAULT = nil
$LANG_CONSOLE_DEFAULT = :en_US
$CHARSET_CONSOLE_DEFAULT = nil

$LANG_FILE = $LANG_FILE_DEFAULT
$CHARSET_FILE = $CHARSET_FILE_DEFAULT
$LANG_CONSOLE = $LANG_CONSOLE_DEFAULT
$CHARSET_CONSOLE = $CHARSET_CONSOLE_DEFAULT

# -k ǻǽʥ
$CODE_TYPE_ARRAY = [ "euc", "sjis", "none", "utf8" ]

# ꤹ
set_lang_var

# 졢ɤΥå
lang_file, charset_file, res =
  resolve_alias_and_check( $LANG_FILE, $CHARSET_FILE )
if res == false then
  # lang_file, charset_file = lang_file_default, charset_file_default
  lang_file, charset_file = $LANG_FILE_DEFAULT, $CHARSET_FILE_DEFAULT
end
lang_console, charset_console, res =
  resolve_alias_and_check( $LANG_CONSOLE, $CHARSET_CONSOLE )
if res == false then
  # lang_console, charset_console = lang_console_default, charset_console_default
  lang_console, charset_console = $LANG_CONSOLE_DEFAULT, $CHARSET_CONSOLE_DEFAULT
end

# å⥸塼
if require_tecsgen_lib( "tecslib/messages/messages_console_#{lang_console}.rb", false ) == false then
  require_tecsgen_lib( "tecslib/messages/messages_console_#{lang_console_default}.rb" )
  $LANG_CONSOLE, $CHARSET_CONSOLE = $LANG_CONSOLE_DEFAULT, $CHARSET_CONSOLE_DEFAULT
else
  $LANG_CONSOLE, $CHARSET_CONSOLE = lang_console, charset_console
end
if require_tecsgen_lib( "tecslib/messages/messages_file_#{lang_file}.rb", false ) == false then
  require_tecsgen_lib( "tecslib/messages/messages_file_#{lang_file_default}.rb" )
  $LANG_FILE, $CHARSET_FILE = $LANG_FILE_DEFAULT, $CHARSET_FILE_DEFAULT
else
  $LANG_FILE, $CHARSET_FILE = lang_file, charset_file
end

# Kconv 饹Τѿ
set_kconv_var 

dbgPrint "LANG_FILE=#{$LANG_FILE}.#{$CHARSET_FILE}, LANG_CONSOLE=#{$LANG_CONSOLE}.#{$CHARSET_CONSOLE}\n"
dbgPrint "KCODE_CDL=#{$KCODE_CDL}(#{$KCONV_CDL}) KCODE_CONSOLE=#{$KCODE_CONSOLE}(#{$KCONV_CONSOLE})\n"

#=== ñΥƥȼ¹
if $unit_test then
  print "unit test: set_lang_var\n"
  require "kconv"
  set_lang_var
  print "#{$LANG_FILE} #{$LANG_CONSOLE}\n"
  print "#{$CHARSET_FILE} #{$CHARSET_CONSOLE}\n"

  $LANG_FILE, $CHARSET_FILE, res = resolve_alias_and_check( $LANG_FILE, $CHARSET_FILE )
  print "#{$LANG_FILE} #{$CHARSET_FILE}, #{res}\n"
end

#= Console 饹
# ʸɤѴ
class Console
  def self.print str
    STDOUT.print str.kconv( $KCONV_CONSOLE, $KCONV_TECSGEN )
  end
  def self.puts str
    STDOUT.puts str.kconv( $KCONV_CONSOLE, $KCONV_TECSGEN )
  end
end
